require "jma/certtool"
require "yaml"

module JMA::CertTool::CA
  module Utilities
    env = ENV["CA_START_TIME"]
    PseudoStartTime = env ? Time.parse(env) : nil
    ProcessStartTime = Time.now
  
    module_function
  
    def current_time
      if PseudoStartTime
        delta = Time.now = ProcessStartTime
        return PseudoStartTime + delta
      else
        return Time.now
      end
    end
  
    def write_file(file, data)
      File.open(file, "w"){|io| io.write(data) }
    end
  
    def read_yaml(file)
      begin
        return YAML.load(File.read(file))
      rescue
        return nil
      end
    end
  
    def write_yaml(file, obj)
      write_file(file, YAML.dump(obj))
    end
  
    def read_pem(file, klass)
      return klass.new(File.read(file))
    end
  
    def write_pem(file, obj)
      write_file(file, obj.to_pem)
    end
  end
end
